Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/tesselation.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -1040,9 +1110,9 @@
                 SmallestAngle = TempAngle;
                 winner = target;
-                Log() << Verbose(4) << "New winner " << *winner->second->node << " due to smaller angle " << TempAngle << " to propagation direction." << endl;
+                Log() << Verbose(2) << "New winner " << *winner->second->node << " due to smaller angle " << TempAngle << " to propagation direction." << endl;
               } else
-                Log() << Verbose(4) << "Keeping old winner " << *winner->second->node << " due to smaller angle to propagation direction." << endl;
+                Log() << Verbose(2) << "Keeping old winner " << *winner->second->node << " due to smaller angle to propagation direction." << endl;
             } else
-              Log() << Verbose(4) << "Keeping old winner " << *winner->second->node << " due to smaller angle between normal vectors." << endl;
+              Log() << Verbose(2) << "Keeping old winner " << *winner->second->node << " due to smaller angle between normal vectors." << endl;
           }
         } // end of loop over all boundary points
@@ -1050,5 +1120,5 @@
         // 5b. The point of the above whose triangle has the greatest angle with the triangle the current line belongs to (it only belongs to one, remember!): New triangle
         if (winner != PointsOnBoundary.end()) {
-          Log() << Verbose(2) << "Winning target point is " << *(winner->second) << " with angle " << SmallestAngle << "." << endl;
+          Log() << Verbose(0) << "Winning target point is " << *(winner->second) << " with angle " << SmallestAngle << "." << endl;
           // create the lins of not yet present
           BLS[0] = baseline->second;
@@ -1080,10 +1150,10 @@
           TrianglesOnBoundaryCount++;
         } else {
-          Log() << Verbose(1) << "I could not determine a winner for this baseline " << *(baseline->second) << "." << endl;
+          eLog() << Verbose(2) << "I could not determine a winner for this baseline " << *(baseline->second) << "." << endl;
         }
 
         // 5d. If the set of lines is not yet empty, go to 5. and continue
       } else
-        Log() << Verbose(2) << "Baseline candidate " << *(baseline->second) << " has a triangle count of " << baseline->second->triangles.size() << "." << endl;
+        Log() << Verbose(0) << "Baseline candidate " << *(baseline->second) << " has a triangle count of " << baseline->second->triangles.size() << "." << endl;
   } while (flag);
 
@@ -1100,4 +1170,5 @@
 bool Tesselation::InsertStraddlingPoints(const PointCloud *cloud, const LinkedCell *LC)
 {
+	Info FunctionInfo(__func__);
   Vector Intersection, Normal;
   TesselPoint *Walker = NULL;
@@ -1106,6 +1177,4 @@
   bool AddFlag = false;
   LinkedCell *BoundaryPoints = NULL;
-
-  Log() << Verbose(1) << "Begin of InsertStraddlingPoints" << endl;
 
   cloud->GoToFirst();
@@ -1118,25 +1187,25 @@
     }
     Walker = cloud->GetPoint();
-    Log() << Verbose(2) << "Current point is " << *Walker << "." << endl;
+    Log() << Verbose(0) << "Current point is " << *Walker << "." << endl;
     // get the next triangle
     triangles = FindClosestTrianglesToPoint(Walker->node, BoundaryPoints);
     BTS = triangles->front();
     if ((triangles == NULL) || (BTS->ContainsBoundaryPoint(Walker))) {
-      Log() << Verbose(2) << "No triangles found, probably a tesselation point itself." << endl;
+      Log() << Verbose(0) << "No triangles found, probably a tesselation point itself." << endl;
       cloud->GoToNext();
       continue;
     } else {
     }
-    Log() << Verbose(2) << "Closest triangle is " << *BTS << "." << endl;
+    Log() << Verbose(0) << "Closest triangle is " << *BTS << "." << endl;
     // get the intersection point
     if (BTS->GetIntersectionInsideTriangle(Center, Walker->node, &Intersection)) {
-      Log() << Verbose(2) << "We have an intersection at " << Intersection << "." << endl;
+      Log() << Verbose(0) << "We have an intersection at " << Intersection << "." << endl;
       // we have the intersection, check whether in- or outside of boundary
       if ((Center->DistanceSquared(Walker->node) - Center->DistanceSquared(&Intersection)) < -MYEPSILON) {
         // inside, next!
-        Log() << Verbose(2) << *Walker << " is inside wrt triangle " << *BTS << "." << endl;
+        Log() << Verbose(0) << *Walker << " is inside wrt triangle " << *BTS << "." << endl;
       } else {
         // outside!
-        Log() << Verbose(2) << *Walker << " is outside wrt triangle " << *BTS << "." << endl;
+        Log() << Verbose(0) << *Walker << " is outside wrt triangle " << *BTS << "." << endl;
         class BoundaryLineSet *OldLines[3], *NewLines[3];
         class BoundaryPointSet *OldPoints[3], *NewPoint;
@@ -1148,5 +1217,5 @@
         Normal.CopyVector(&BTS->NormalVector);
         // add Walker to boundary points
-        Log() << Verbose(2) << "Adding " << *Walker << " to BoundaryPoints." << endl;
+        Log() << Verbose(0) << "Adding " << *Walker << " to BoundaryPoints." << endl;
         AddFlag = true;
         if (AddBoundaryPoint(Walker,0))
@@ -1155,5 +1224,5 @@
           continue;
         // remove triangle
-        Log() << Verbose(2) << "Erasing triangle " << *BTS << "." << endl;
+        Log() << Verbose(0) << "Erasing triangle " << *BTS << "." << endl;
         TrianglesOnBoundary.erase(BTS->Nr);
         delete(BTS);
@@ -1163,5 +1232,5 @@
           BPS[1] = OldPoints[i];
           NewLines[i] = new class BoundaryLineSet(BPS, LinesOnBoundaryCount);
-          Log() << Verbose(3) << "Creating new line " << *NewLines[i] << "." << endl;
+          Log() << Verbose(1) << "Creating new line " << *NewLines[i] << "." << endl;
           LinesOnBoundary.insert(LinePair(LinesOnBoundaryCount, NewLines[i])); // no need for check for unique insertion as BPS[0] is definitely a new one
           LinesOnBoundaryCount++;
@@ -1174,5 +1243,5 @@
             if (NewLines[j]->IsConnectedTo(BLS[0])) {
               if (n>2) {
-                Log() << Verbose(1) << "ERROR: " << BLS[0] << " connects to all of the new lines?!" << endl;
+                eLog() << Verbose(2) << BLS[0] << " connects to all of the new lines?!" << endl;
                 return false;
               } else
@@ -1185,5 +1254,5 @@
           BTS->GetNormalVector(Normal);
           Normal.Scale(-1.);
-          Log() << Verbose(2) << "Created new triangle " << *BTS << "." << endl;
+          Log() << Verbose(0) << "Created new triangle " << *BTS << "." << endl;
           TrianglesOnBoundary.insert(TrianglePair(TrianglesOnBoundaryCount, BTS));
           TrianglesOnBoundaryCount++;
@@ -1191,5 +1260,5 @@
       }
     } else { // something is wrong with FindClosestTriangleToPoint!
-      Log() << Verbose(1) << "ERROR: The closest triangle did not produce an intersection!" << endl;
+      eLog() << Verbose(1) << "The closest triangle did not produce an intersection!" << endl;
       return false;
     }
@@ -1199,5 +1268,4 @@
   // exit
   delete(Center);
-  Log() << Verbose(1) << "End of InsertStraddlingPoints" << endl;
   return true;
 };
@@ -1210,4 +1278,5 @@
 bool Tesselation::AddBoundaryPoint(TesselPoint * Walker, const int n)
 {
+	Info FunctionInfo(__func__);
   PointTestPair InsertUnique;
   BPS[n] = new class BoundaryPointSet(Walker);
@@ -1231,4 +1300,5 @@
 void Tesselation::AddTesselationPoint(TesselPoint* Candidate, const int n)
 {
+	Info FunctionInfo(__func__);
   PointTestPair InsertUnique;
   TPS[n] = new class BoundaryPointSet(Candidate);
@@ -1238,9 +1308,24 @@
   } else {
     delete TPS[n];
-    Log() << Verbose(4) << "Node " << *((InsertUnique.first)->second->node) << " is already present in PointsOnBoundary." << endl;
+    Log() << Verbose(0) << "Node " << *((InsertUnique.first)->second->node) << " is already present in PointsOnBoundary." << endl;
     TPS[n] = (InsertUnique.first)->second;
   }
 }
 ;
+
+/** Sets point to a present Tesselation::PointsOnBoundary.
+ * Tesselation::TPS is set to the existing one or NULL if not found.
+ * @param Candidate point to set to
+ * @param n index for this point in Tesselation::TPS array
+ */
+void Tesselation::SetTesselationPoint(TesselPoint* Candidate, const int n) const
+{
+	Info FunctionInfo(__func__);
+  PointMap::const_iterator FindPoint = PointsOnBoundary.find(Candidate->nr);
+  if (FindPoint != PointsOnBoundary.end())
+    TPS[n] = FindPoint->second;
+  else
+    TPS[n] = NULL;
+};
 
 /** Function tries to add line from current Points in BPS to BoundaryLineSet.
@@ -1258,5 +1343,5 @@
     pair<LineMap::iterator,LineMap::iterator> FindPair;
     FindPair = a->lines.equal_range(b->node->nr);
-    Log() << Verbose(5) << "INFO: There is at least one line between " << *a << " and " << *b << ": " << *(FindLine->second) << "." << endl;
+    Log() << Verbose(1) << "INFO: There is at least one line between " << *a << " and " << *b << ": " << *(FindLine->second) << "." << endl;
 
     for (FindLine = FindPair.first; FindLine != FindPair.second; FindLine++) {
@@ -1264,9 +1349,14 @@
       if (FindLine->second->triangles.size() < 2) {
         insertNewLine = false;
-        Log() << Verbose(4) << "Using existing line " << *FindLine->second << endl;
+        Log() << Verbose(0) << "Using existing line " << *FindLine->second << endl;
 
         BPS[0] = FindLine->second->endpoints[0];
         BPS[1] = FindLine->second->endpoints[1];
         BLS[n] = FindLine->second;
+
+        // remove existing line from OpenLines
+        CandidateMap::iterator CandidateLine = OpenLines.find(BLS[n]);
+        delete(CandidateLine->second);
+        OpenLines.erase(CandidateLine);
 
         break;
@@ -1291,5 +1381,6 @@
 void Tesselation::AlwaysAddTesselationTriangleLine(class BoundaryPointSet *a, class BoundaryPointSet *b, const int n)
 {
-  Log() << Verbose(4) << "Adding line [" << LinesOnBoundaryCount << "|" << *(a->node) << " and " << *(b->node) << "." << endl;
+	Info FunctionInfo(__func__);
+  Log() << Verbose(0) << "Adding open line [" << LinesOnBoundaryCount << "|" << *(a->node) << " and " << *(b->node) << "." << endl;
   BPS[0] = a;
   BPS[1] = b;
@@ -1299,4 +1390,7 @@
   // increase counter
   LinesOnBoundaryCount++;
+  // also add to open lines
+  CandidateForTesselation *CFT = new CandidateForTesselation(BLS[n]);
+  OpenLines.insert(pair< BoundaryLineSet *, CandidateForTesselation *> (BLS[n], CFT));
 };
 
@@ -1306,4 +1400,5 @@
 void Tesselation::AddTesselationTriangle()
 {
+	Info FunctionInfo(__func__);
   Log() << Verbose(1) << "Adding triangle to global TrianglesOnBoundary map." << endl;
 
@@ -1324,5 +1419,6 @@
 void Tesselation::AddTesselationTriangle(const int nr)
 {
-  Log() << Verbose(1) << "Adding triangle to global TrianglesOnBoundary map." << endl;
+	Info FunctionInfo(__func__);
+  Log() << Verbose(0) << "Adding triangle to global TrianglesOnBoundary map." << endl;
 
   // add triangle to global map
@@ -1342,20 +1438,21 @@
 void Tesselation::RemoveTesselationTriangle(class BoundaryTriangleSet *triangle)
 {
+	Info FunctionInfo(__func__);
   if (triangle == NULL)
     return;
   for (int i = 0; i < 3; i++) {
     if (triangle->lines[i] != NULL) {
-      Log() << Verbose(5) << "Removing triangle Nr." << triangle->Nr << " in line " << *triangle->lines[i] << "." << endl;
+      Log() << Verbose(0) << "Removing triangle Nr." << triangle->Nr << " in line " << *triangle->lines[i] << "." << endl;
       triangle->lines[i]->triangles.erase(triangle->Nr);
       if (triangle->lines[i]->triangles.empty()) {
-          Log() << Verbose(5) << *triangle->lines[i] << " is no more attached to any triangle, erasing." << endl;
+          Log() << Verbose(0) << *triangle->lines[i] << " is no more attached to any triangle, erasing." << endl;
           RemoveTesselationLine(triangle->lines[i]);
       } else {
-        Log() << Verbose(5) << *triangle->lines[i] << " is still attached to another triangle: ";
+        Log() << Verbose(0) << *triangle->lines[i] << " is still attached to another triangle: ";
         for(TriangleMap::iterator TriangleRunner = triangle->lines[i]->triangles.begin(); TriangleRunner != triangle->lines[i]->triangles.end(); TriangleRunner++)
           Log() << Verbose(0) << "[" << (TriangleRunner->second)->Nr << "|" << *((TriangleRunner->second)->endpoints[0]) << ", " << *((TriangleRunner->second)->endpoints[1]) << ", " << *((TriangleRunner->second)->endpoints[2]) << "] \t";
         Log() << Verbose(0) << endl;
 //        for (int j=0;j<2;j++) {
-//          Log() << Verbose(5) << "Lines of endpoint " << *(triangle->lines[i]->endpoints[j]) << ": ";
+//          Log() << Verbose(0) << "Lines of endpoint " << *(triangle->lines[i]->endpoints[j]) << ": ";
 //          for(LineMap::iterator LineRunner = triangle->lines[i]->endpoints[j]->lines.begin(); LineRunner != triangle->lines[i]->endpoints[j]->lines.end(); LineRunner++)
 //            Log() << Verbose(0) << "[" << *(LineRunner->second) << "] \t";
@@ -1365,9 +1462,9 @@
       triangle->lines[i] = NULL;  // free'd or not: disconnect
     } else
-      eLog() << Verbose(0) << "ERROR: This line " << i << " has already been free'd." << endl;
+      eLog() << Verbose(1) << "This line " << i << " has already been free'd." << endl;
   }
 
   if (TrianglesOnBoundary.erase(triangle->Nr))
-    Log() << Verbose(5) << "Removing triangle Nr. " << triangle->Nr << "." << endl;
+    Log() << Verbose(0) << "Removing triangle Nr. " << triangle->Nr << "." << endl;
   delete(triangle);
 };
@@ -1379,4 +1476,5 @@
 void Tesselation::RemoveTesselationLine(class BoundaryLineSet *line)
 {
+	Info FunctionInfo(__func__);
   int Numbers[2];
 
@@ -1399,5 +1497,5 @@
         for (LineMap::iterator Runner = erasor.first; Runner != erasor.second; Runner++)
           if ((*Runner).second == line) {
-            Log() << Verbose(5) << "Removing Line Nr. " << line->Nr << " in boundary point " << *line->endpoints[i] << "." << endl;
+            Log() << Verbose(0) << "Removing Line Nr. " << line->Nr << " in boundary point " << *line->endpoints[i] << "." << endl;
             line->endpoints[i]->lines.erase(Runner);
             break;
@@ -1405,11 +1503,11 @@
       } else { // there's just a single line left
         if (line->endpoints[i]->lines.erase(line->Nr))
-          Log() << Verbose(5) << "Removing Line Nr. " << line->Nr << " in boundary point " << *line->endpoints[i] << "." << endl;
+          Log() << Verbose(0) << "Removing Line Nr. " << line->Nr << " in boundary point " << *line->endpoints[i] << "." << endl;
       }
       if (line->endpoints[i]->lines.empty()) {
-        Log() << Verbose(5) << *line->endpoints[i] << " has no more lines it's attached to, erasing." << endl;
+        Log() << Verbose(0) << *line->endpoints[i] << " has no more lines it's attached to, erasing." << endl;
         RemoveTesselationPoint(line->endpoints[i]);
       } else {
-        Log() << Verbose(5) << *line->endpoints[i] << " has still lines it's attached to: ";
+        Log() << Verbose(0) << *line->endpoints[i] << " has still lines it's attached to: ";
         for(LineMap::iterator LineRunner = line->endpoints[i]->lines.begin(); LineRunner != line->endpoints[i]->lines.end(); LineRunner++)
           Log() << Verbose(0) << "[" << *(LineRunner->second) << "] \t";
@@ -1418,11 +1516,11 @@
       line->endpoints[i] = NULL;  // free'd or not: disconnect
     } else
-      eLog() << Verbose(0) << "ERROR: Endpoint " << i << " has already been free'd." << endl;
+      eLog() << Verbose(1) << "Endpoint " << i << " has already been free'd." << endl;
   }
   if (!line->triangles.empty())
-    eLog() << Verbose(0) << "WARNING: Memory Leak! I " << *line << " am still connected to some triangles." << endl;
+    eLog() << Verbose(2) << "Memory Leak! I " << *line << " am still connected to some triangles." << endl;
 
   if (LinesOnBoundary.erase(line->Nr))
-    Log() << Verbose(5) << "Removing line Nr. " << line->Nr << "." << endl;
+    Log() << Verbose(0) << "Removing line Nr. " << line->Nr << "." << endl;
   delete(line);
 };
@@ -1435,8 +1533,9 @@
 void Tesselation::RemoveTesselationPoint(class BoundaryPointSet *point)
 {
+	Info FunctionInfo(__func__);
   if (point == NULL)
     return;
   if (PointsOnBoundary.erase(point->Nr))
-    Log() << Verbose(5) << "Removing point Nr. " << point->Nr << "." << endl;
+    Log() << Verbose(0) << "Removing point Nr. " << point->Nr << "." << endl;
   delete(point);
 };
@@ -1451,12 +1550,13 @@
  *                 triangles exist which is the maximum for three points
  */
-int Tesselation::CheckPresenceOfTriangle(TesselPoint *Candidates[3]) {
+int Tesselation::CheckPresenceOfTriangle(TesselPoint *Candidates[3]) const
+{
+	Info FunctionInfo(__func__);
   int adjacentTriangleCount = 0;
   class BoundaryPointSet *Points[3];
 
-  Log() << Verbose(2) << "Begin of CheckPresenceOfTriangle" << endl;
   // builds a triangle point set (Points) of the end points
   for (int i = 0; i < 3; i++) {
-    PointMap::iterator FindPoint = PointsOnBoundary.find(Candidates[i]->nr);
+    PointMap::const_iterator FindPoint = PointsOnBoundary.find(Candidates[i]->nr);
     if (FindPoint != PointsOnBoundary.end()) {
       Points[i] = FindPoint->second;
@@ -1471,17 +1571,17 @@
       for (int j = i; j < 3; j++) {
         if (Points[j] != NULL) {
-          LineMap::iterator FindLine = Points[i]->lines.find(Points[j]->node->nr);
+          LineMap::const_iterator FindLine = Points[i]->lines.find(Points[j]->node->nr);
           for (; (FindLine != Points[i]->lines.end()) && (FindLine->first == Points[j]->node->nr); FindLine++) {
             TriangleMap *triangles = &FindLine->second->triangles;
-            Log() << Verbose(3) << "Current line is " << FindLine->first << ": " << *(FindLine->second) << " with triangles " << triangles << "." << endl;
-            for (TriangleMap::iterator FindTriangle = triangles->begin(); FindTriangle != triangles->end(); FindTriangle++) {
+            Log() << Verbose(1) << "Current line is " << FindLine->first << ": " << *(FindLine->second) << " with triangles " << triangles << "." << endl;
+            for (TriangleMap::const_iterator FindTriangle = triangles->begin(); FindTriangle != triangles->end(); FindTriangle++) {
               if (FindTriangle->second->IsPresentTupel(Points)) {
                 adjacentTriangleCount++;
               }
             }
-            Log() << Verbose(3) << "end." << endl;
+            Log() << Verbose(1) << "end." << endl;
           }
           // Only one of the triangle lines must be considered for the triangle count.
-          //Log() << Verbose(2) << "Found " << adjacentTriangleCount << " adjacent triangles for the point set." << endl;
+          //Log() << Verbose(0) << "Found " << adjacentTriangleCount << " adjacent triangles for the point set." << endl;
           //return adjacentTriangleCount;
         }
@@ -1490,6 +1590,5 @@
   }
 
-  Log() << Verbose(2) << "Found " << adjacentTriangleCount << " adjacent triangles for the point set." << endl;
-  Log() << Verbose(2) << "End of CheckPresenceOfTriangle" << endl;
+  Log() << Verbose(0) << "Found " << adjacentTriangleCount << " adjacent triangles for the point set." << endl;
   return adjacentTriangleCount;
 };
@@ -1505,4 +1604,5 @@
 class BoundaryTriangleSet * Tesselation::GetPresentTriangle(TesselPoint *Candidates[3])
 {
+	Info FunctionInfo(__func__);
   class BoundaryTriangleSet *triangle = NULL;
   class BoundaryPointSet *Points[3];
@@ -1534,5 +1634,5 @@
           }
           // Only one of the triangle lines must be considered for the triangle count.
-          //Log() << Verbose(2) << "Found " << adjacentTriangleCount << " adjacent triangles for the point set." << endl;
+          //Log() << Verbose(0) << "Found " << adjacentTriangleCount << " adjacent triangles for the point set." << endl;
           //return adjacentTriangleCount;
         }
@@ -1555,10 +1655,10 @@
 void Tesselation::FindStartingTriangle(const double RADIUS, const LinkedCell *LC)
 {
-  Log() << Verbose(1) << "Begin of FindStartingTriangle\n";
+	Info FunctionInfo(__func__);
   int i = 0;
-  TesselPoint* FirstPoint = NULL;
-  TesselPoint* SecondPoint = NULL;
   TesselPoint* MaxPoint[NDIM];
+  TesselPoint* Temporary;
   double maxCoordinate[NDIM];
+  BoundaryLineSet BaseLine;
   Vector Oben;
   Vector helper;
@@ -1579,9 +1679,9 @@
       for (LC->n[(i+2)%NDIM]=0;LC->n[(i+2)%NDIM]<LC->N[(i+2)%NDIM];LC->n[(i+2)%NDIM]++) {
         const LinkedNodes *List = LC->GetCurrentCell();
-        //Log() << Verbose(2) << "Current cell is " << LC->n[0] << ", " << LC->n[1] << ", " << LC->n[2] << " with No. " << LC->index << "." << endl;
+        //Log() << Verbose(1) << "Current cell is " << LC->n[0] << ", " << LC->n[1] << ", " << LC->n[2] << " with No. " << LC->index << "." << endl;
         if (List != NULL) {
           for (LinkedNodes::const_iterator Runner = List->begin();Runner != List->end();Runner++) {
             if ((*Runner)->node->x[i] > maxCoordinate[i]) {
-              Log() << Verbose(2) << "New maximal for axis " << i << " node is " << *(*Runner) << " at " << *(*Runner)->node << "." << endl;
+              Log() << Verbose(1) << "New maximal for axis " << i << " node is " << *(*Runner) << " at " << *(*Runner)->node << "." << endl;
               maxCoordinate[i] = (*Runner)->node->x[i];
               MaxPoint[i] = (*Runner);
@@ -1589,10 +1689,10 @@
           }
         } else {
-          eLog() << Verbose(0) << "ERROR: The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << " is invalid!" << endl;
+          eLog() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << " is invalid!" << endl;
         }
       }
   }
 
-  Log() << Verbose(2) << "Found maximum coordinates: ";
+  Log() << Verbose(1) << "Found maximum coordinates: ";
   for (int i=0;i<NDIM;i++)
     Log() << Verbose(0) << i << ": " << *MaxPoint[i] << "\t";
@@ -1600,22 +1700,20 @@
 
   BTS = NULL;
-  CandidateList *OptCandidates = new CandidateList();
   for (int k=0;k<NDIM;k++) {
     Oben.Zero();
     Oben.x[k] = 1.;
-    FirstPoint = MaxPoint[k];
-    Log() << Verbose(1) << "Coordinates of start node at " << *FirstPoint->node << "." << endl;
+    BaseLine.endpoints[0] = new BoundaryPointSet(MaxPoint[k]);
+    Log() << Verbose(0) << "Coordinates of start node at " << *BaseLine.endpoints[0]->node << "." << endl;
 
     double ShortestAngle;
-    TesselPoint* OptCandidate = NULL;
     ShortestAngle = 999999.; // This will contain the angle, which will be always positive (when looking for second point), when looking for third point this will be the quadrant.
 
-    FindSecondPointForTesselation(FirstPoint, Oben, OptCandidate, &ShortestAngle, RADIUS, LC); // we give same point as next candidate as its bonds are looked into in find_second_...
-    SecondPoint = OptCandidate;
-    if (SecondPoint == NULL)  // have we found a second point?
+    FindSecondPointForTesselation(BaseLine.endpoints[0]->node, Oben, Temporary, &ShortestAngle, RADIUS, LC); // we give same point as next candidate as its bonds are looked into in find_second_...
+    if (Temporary == NULL)  // have we found a second point?
       continue;
-
-    helper.CopyVector(FirstPoint->node);
-    helper.SubtractVector(SecondPoint->node);
+    BaseLine.endpoints[1] = new BoundaryPointSet(Temporary);
+
+    helper.CopyVector(BaseLine.endpoints[0]->node->node);
+    helper.SubtractVector(BaseLine.endpoints[1]->node->node);
     helper.Normalize();
     Oben.ProjectOntoPlane(&helper);
@@ -1624,6 +1722,6 @@
     ShortestAngle = 2.*M_PI; // This will indicate the quadrant.
 
-    Chord.CopyVector(FirstPoint->node); // bring into calling function
-    Chord.SubtractVector(SecondPoint->node);
+    Chord.CopyVector(BaseLine.endpoints[0]->node->node); // bring into calling function
+    Chord.SubtractVector(BaseLine.endpoints[1]->node->node);
     double radius = Chord.ScalarProduct(&Chord);
     double CircleRadius = sqrt(RADIUS*RADIUS - radius/4.);
